/*
        FILE :                  object.h

        DESCRIPTION :           Definition of objects routines

        AUTHOR :                Trax / Aspirine (c), 1999

        VERSION :               0.1b
*/

#ifndef _OBJECT_H_INCLUDED
#define _OBJECT_H_INCLUDED

//// INCLUDES /////////////////////////////////////////////////////////////////

#include "3dstruct.h"
#include "matrix.h"
#include "vector.h"
#include "loadasc.h"

//// DEFINES //////////////////////////////////////////////////////////////////

#define p_flat                  0
#define p_gouraud               1
#define p_texture               2
#define p_texturegouraud        3
#define p_gouraudtexture        3
#define p_phong                 4
#define p_envmap                5
// hidden face removal enabled:
#define p_hfre                  16

//// PROTOTYPES ///////////////////////////////////////////////////////////////

void dispose_object(SCENE *scene, int nro);

///////////////////////////////////////////////////////////////////////////////

void obj_loader_init(SCENE *scene, int max_objects);

///////////////////////////////////////////////////////////////////////////////

void free_object_structs(SCENE *scene);

///////////////////////////////////////////////////////////////////////////////

void all_objects_loaded(SCENE *scene);

///////////////////////////////////////////////////////////////////////////////

void calc_vertex_normals(SCENE *scene, unsigned int nro);

///////////////////////////////////////////////////////////////////////////////

void calc_object_data(SCENE *scene, unsigned int nro);

///////////////////////////////////////////////////////////////////////////////

void set_flags(OBJECT *obu, unsigned int flgs, unsigned char textnro,
               unsigned char r, unsigned char g, unsigned char b);

///////////////////////////////////////////////////////////////////////////////

signed int new_obj(SCENE *scene, char *filename,float mul,
                   float xpos, float ypos, float zpos,
                   unsigned int flags, unsigned char textnro,
                   unsigned char r, unsigned char g, unsigned char b);

///////////////////////////////////////////////////////////////////////////////

void object_update(SCENE *scene, unsigned int nro,
                   float xa, float ya, float za,
                   float s_rt, float s_dn, float s_fw);

///////////////////////////////////////////////////////////////////////////////

void putobject(SCENE *scene, unsigned int nro, CAMERA *camera);



#endif
