/*
        FILE :                  polygon.h

        DESCRIPTION :           Definition of polygon routines

        AUTHOR :                Trax / Aspirine (c), 1999

        VERSION :               0.1b
*/

#ifndef _POLYGON_H_INCLUDED
#define _POLYGON_H_INCLUDED

//// INCLUDES /////////////////////////////////////////////////////////////////

#include "3dstruct.h"

//// EXTERNS //////////////////////////////////////////////////////////////////

extern unsigned int *buffer;
extern int xres;

extern int c_left;
extern int c_right;
extern int c_up;
extern int c_down;


//// PROTOTYPES ///////////////////////////////////////////////////////////////

// flat 
void kol(POL_VERTEX *v1, POL_VERTEX *v2, POL_VERTEX *v3);

// gouraud
void gkol(POL_VERTEX *v1, POL_VERTEX *v2, POL_VERTEX *v3);

// linear texture
void ltkol(POL_VERTEX *v1, POL_VERTEX *v2, POL_VERTEX *v3, char *from, char *palette);

// perspective texture
void ptkol(POL_VERTEX *v1, POL_VERTEX *v2, POL_VERTEX *v3, char *from, char *palette);

// "phong" 
void pkol(POL_VERTEX *v1, POL_VERTEX *v2, POL_VERTEX *v3, LIGHT light);

// gouraud texture
void lgtkol(POL_VERTEX *v1, POL_VERTEX *v2, POL_VERTEX *v3, char *from, char *palette);



#endif
